unit Unit1;
{Internet Activity Monitor Demo. Written by Tan Chi Thai and Kate Lindon.

 1. When monitoring files, please note that some files show are system file.
    Examples of systems files are:
                ALG.exe      (Microsoft Application Gateway)
                SVCHOST.exe  (GENERIC Host Process for Win32 Services)
                LSASS.exe    (LSA Shell)
   Where the handle of these file is equal to zero, the file path will NOT be shown.
   Normal Applications Files cannot have their HANDLE to be zero. Thus, if you
   are tracking suspicious applications, their file path will be accessible.

 2. To see FULL list of files and their descriptions(NOT only to TCP/UDP connections)
    try out DLL Show [class] with examples by
    Citisoft:   http://www.chithai.com/delphi/dllshow

 3. Several SVCHOST.exe are at service each time. If any of them is IDLE, you will
    not see the file path. Instead the path of idle services will be shown as 'SYSTEM PATH',
    since it is not accessible. So, do not be confused here. These details are given
    only for clarification - they are not useful in anyway if your aim to to trap
    e-mails worms.

 4. When the application has run for about 6 minutes, the UPDATE panel will
    stop blinking and thus stop updating. You will have to re-start your project.
    This applies to the evaluation copy}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, WormsTrackerXP, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    ListView1: TListView;
    ListView2: TListView;
    WormsTracker1: TWormsTracker;
    Panel5: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure WormsTracker1RefreshProcess(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
    {LISTVIEW SEEMS TO FLICKER LESS THIS WAY
    IF YOU HAVE A GRAND IDEA FOR IMPROVEMENT, DO PLEASE LET US KNOW}
procedure ListviewCreateItems;  
var i:integer;
    li:TListitem;
begin          with Form1 do BEGIN
               {Create Listitems in Listview1 and Listview2}
               
{NOTE: if you have more processes running on your PC, you will have to change
50 to a higher figure - say 100}

      For i := 0 to 50 do begin
          li := ListView1.Items.Add;
        
          li.SubItems.Add(''); {PID}
          li.SubItems.Add(''); {Process Name}
          li.Subitems.Add(''); {Remote Address}
          li.Subitems.Add(''); {Status}
          li.Subitems.Add(''); {FilePath}
          li.Subitems.Add(''); {Protocol}
                         end;
      For i := 0 to 50 do begin
          li := ListView2.Items.Add;
          li.Caption := inttostr(i);
          li.SubItems.Add('');
          li.SubItems.Add('');
          li.SubItems.Add('');
          li.SubItems.Add('');
          li.Subitems.Add('');
          li.Subitems.Add('');
                         end;


                             END;
end;
{------------------------------------------------------------------------------}

{------------------------------------------------------------------------------}

procedure ClearListview;
var i :integer;
begin            With form1 do begin

           For    i := 0 to Listview1.items.Count-1 do begin
               Listview1.Items[i].Caption := '' ;
               Listview1.Items[i].SubItems[0]:='' ;
               Listview1.Items[i].SubItems[1]:='' ;
               Listview1.Items[i].SubItems[2]:='' ;
               Listview1.Items[i].SubItems[3]:='' ;
               Listview1.Items[i].SubItems[4]:='' ;
               Listview1.Items[i].SubItems[5]:='' ;
                                                    end;

           For    i := 0 to Listview1.items.Count-1 do begin
               Listview2.Items[i].Caption := '' ;
               Listview2.Items[i].SubItems[0]:='' ;
               Listview2.Items[i].SubItems[1]:='' ;
               Listview2.Items[i].SubItems[2]:='' ;
               Listview2.Items[i].SubItems[3]:='' ;
               Listview2.Items[i].SubItems[4]:='' ;
                                                    end;

                               end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin    {You have to enable the internal TIMER}
         WormsTracker1.TimerEnabled := TRUE;
         ListviewCreateItems;
end;

procedure TForm1.WormsTracker1RefreshProcess(Sender: TObject);
var i:integer;
begin
                    ClearListview;
{1.You can compare your executable list here. If you want to list only the executables,
then use :
      If LOWERCASE(ExtractFileExt(WormsTracker1.TCPProcess[i])) := 'exe'
                                       then...  do whatever you like
 2. The service use by a process is attached to the RemoteAddress demarcated by a :[colon].
    So if a certain application is sending mail, you will see something like:
                             35.9.25.10:SMTP
    SMTP is the simple mail protocol service. You can then terminate the application if
    you feel like to. On the other hand if an application is receiving mails,
    then you will see something like:
                            66.102.7.104:POP3
    if application is using POP3 service }

       {Add  TCP items}
       For i := 0 to WormsTracker1.TCPConnections do begin
    Listview1.Items[i].Caption    :=  WormsTracker1.TCPProcess[i].PID;
    Listview1.Items[i].SubItems[0]:=  WormsTracker1.TCPProcess[i].ProcessName ;
    Listview1.Items[i].SubItems[1]:=  WormsTracker1.TCPProcess[i].RemoteAddress;
    Listview1.Items[i].SubItems[2]:=  WormsTracker1.TCPProcess[i].Status ;
    Listview1.Items[i].SubItems[3]:=  WormsTracker1.TCPProcess[i].FilePath ;
    Listview1.Items[i].SubItems[4]:=  WormsTracker1.TCPProcess[i].Protocol ;
    Listview1.Items[i].SubItems[5]:=  WormsTracker1.TCPProcess[i].LocalAddress ;
                                                       end;



       {Add UDP items}
       For i := 0 to WormsTracker1.UDPConnections do begin
    Listview2.Items[i].Caption    :=  WormsTracker1.UDPProcess[i].PID;
    Listview2.Items[i].SubItems[0]:=  WormsTracker1.UDPProcess[i].ProcessName ;
    Listview2.Items[i].SubItems[1]:=  WormsTracker1.UDPProcess[i].RemoteAddress;
    Listview2.Items[i].SubItems[2]:=  WormsTracker1.UDPProcess[i].Status ;
    Listview2.Items[i].SubItems[3]:=  WormsTracker1.UDPProcess[i].FilePath ;
    Listview2.Items[i].SubItems[4]:=  WormsTracker1.UDPProcess[i].Protocol ;
    Listview2.Items[i].SubItems[5]:=  WormsTracker1.UDPProcess[i].LocalAddress ;
                                                       end;

               Panel5.Visible := NOT(Panel5.Visible);
end;

end.
